## phase2 0.1.0-2

=== CMakeLists.txt ===
# CMake script for peptider
# Author: Olivier Langella
# Created: 28/05/2016

# Global parameters
CMAKE_MINIMUM_REQUIRED(VERSION 2.6)
PROJECT(phase2 CXX)
IF(NOT CMAKE_BUILD_TYPE)
#  SET(CMAKE_BUILD_TYPE RelWithDebInfo CACHE STRING
#      "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel."
#      FORCE)
  SET(CMAKE_BUILD_TYPE Debug CACHE STRING
      "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel."
      FORCE)
ENDIF(NOT CMAKE_BUILD_TYPE)

MESSAGE("CMAKE_BUILD_TYPE : ${CMAKE_BUILD_TYPE}")

IF(CMAKE_BUILD_TYPE MATCHES "Release")
  MESSAGE("compiling as release version")
  ADD_DEFINITIONS("-DQT_NO_DEBUG_OUTPUT")
ENDIF( CMAKE_BUILD_TYPE MATCHES "Release" )

IF(CMAKE_BUILD_TYPE MATCHES "Debug")
  MESSAGE("compiling as debug version")
ENDIF( CMAKE_BUILD_TYPE MATCHES "Debug" )

IF(CMAKE_BUILD_TYPE MATCHES "RelWithDebInfo")
  MESSAGE("compiling as release with debug info version")
ENDIF( CMAKE_BUILD_TYPE MATCHES "RelWithDebInfo" )

#SET(CMAKE_CXX_FLAGS "-Wall -Weffc++ -Wshadow -Wconversion")
#SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11")
set(CMAKE_CXX_STANDARD 14)

#depending on libpappsomspp version :
SET(LIBPAPPSOMSPP_VERSION "0.2.37-1")
configure_file (${CMAKE_SOURCE_DIR}/debian/control.cmake ${CMAKE_SOURCE_DIR}/debian/control  @ONLY)


SET(SOFTWARE_NAME "phase2")

SET(PHASE2_VERSION_MAJOR "0")
SET(PHASE2_VERSION_MINOR "1")
SET(PHASE2_VERSION_PATCH "0")
SET(PHASE2_VERSION "${PHASE2_VERSION_MAJOR}.${PHASE2_VERSION_MINOR}.${PHASE2_VERSION_PATCH}")

# Set the CMAKE_PREFIX_PATH for the find_library fonction when using non
# standard install location
IF(CMAKE_INSTALL_PREFIX)
  SET(CMAKE_PREFIX_PATH "${CMAKE_INSTALL_PREFIX}" ${CMAKE_PREFIX_PATH})
ENDIF(CMAKE_INSTALL_PREFIX)

# Subdirectories
ADD_SUBDIRECTORY(src)

# Doxygen
FIND_PACKAGE(Doxygen)
IF (DOXYGEN_FOUND)
  ADD_CUSTOM_TARGET (apidoc cp Doxyfile ${CMAKE_BINARY_DIR}/Doxyfile-build
    COMMAND echo "OUTPUT_DIRECTORY=${CMAKE_BINARY_DIR}" >> ${CMAKE_BINARY_DIR}/Doxyfile-build
    COMMAND ${DOXYGEN_EXECUTABLE} ${CMAKE_BINARY_DIR}/Doxyfile-build
    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})
  ADD_CUSTOM_TARGET (apidoc-stable cp Doxyfile ${CMAKE_BINARY_DIR}/Doxyfile-stable
    COMMAND echo "OUTPUT_DIRECTORY=${CMAKE_BINARY_DIR}" >> ${CMAKE_BINARY_DIR}/Doxyfile-stable
    COMMAND echo "HTML_HEADER=header.html" >> ${CMAKE_BINARY_DIR}/Doxyfile-stable
    COMMAND ${DOXYGEN_EXECUTABLE} ${CMAKE_BINARY_DIR}/Doxyfile-stable
    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})
ENDIF (DOXYGEN_FOUND)

# Packager
SET(CPACK_PACKAGE_NAME "phase2")
SET(CPACK_PACKAGE_VENDOR "PAPPSO Development Team")
SET(CPACK_PACKAGE_VERSION "${PHASE2_VERSION}")
SET(CPACK_PACKAGE_VERSION_MAJOR "${PHASE2_VERSION_MAJOR}")
SET(CPACK_PACKAGE_VERSION_MINOR "${PHASE2_VERSION_MINOR}")
SET(CPACK_PACKAGE_VERSION_PATCH "${PHASE2_VERSION_PATCH}")
SET(CPACK_PACKAGE_DESCRIPTION_SUMMARY "mass spectrometry peptide identifier")
SET(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_SOURCE_DIR}/COPYING")
SET(CPACK_RESOURCE_FILE_AUTHORS "${CMAKE_SOURCE_DIR}/AUTHORS")
SET(CPACK_RESOURCE_FILE_INSTALL "${CMAKE_SOURCE_DIR}/INSTALL")
SET(CPACK_SOURCE_GENERATOR "TGZ")
SET(CPACK_SOURCE_IGNORE_FILES
 "CMakeFiles"
 "Makefile"
 "_CPack_Packages"
 "CMakeCache.txt"
 ".*\\\\.git"
 ".*\\\\.gz"
 ".*\\\\.deb"
 ".*\\\\.rpm"
 ".*\\\\.dmg"
 ".*\\\\..*\\\\.swp"
 "src/\\\\..*"
 "src/libbpp*"
 "debian/tmp"
 "debian/libbpp.*/"
 "debian/libbpp.*\\\\.so.*"
 "debian/libbpp.*\\\\.a"
 "debian/libbpp.*\\\\.substvars"
 "debian/libbpp.*\\\\.debhelper"
 "debian/debhelper\\\\.log"
 "build/"
 "html"
 "Core.tag"
 "Testing"
 "build-stamp"
 "install_manifest.txt"
 "DartConfiguration.tcl"
 ${CPACK_SOURCE_IGNORE_FILES}
)



#dch -Djessie "message"
#cmake ..
#make deb
# scp peptider* proteus.moulon.inra.fr:/var/www/apt/incoming
# reprepro -Vb /var/www/apt processincoming default
#
#  debuild -S -sa

IF (MACOS)
  SET(CPACK_GENERATOR "Bundle")
ENDIF()

SET(CPACK_SOURCE_PACKAGE_FILE_NAME "${CPACK_PACKAGE_NAME}-${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR}.${CPACK_PACKAGE_VERSION_PATCH}")
SET(CPACK_DEBSOURCE_PACKAGE_FILE_NAME "lib${CMAKE_PROJECT_NAME}_${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR}.${CPACK_PACKAGE_VERSION_PATCH}.orig")
INCLUDE(CPack)

#This adds the 'dist' target
ADD_CUSTOM_TARGET(dist COMMAND ${CMAKE_MAKE_PROGRAM} package_source)
# 'clean' is not (yet) a first class target. However, we need to clean the directories before building the sources:
IF("${CMAKE_GENERATOR}" MATCHES "Make")
  ADD_CUSTOM_TARGET(make_clean
  COMMAND ${CMAKE_MAKE_PROGRAM} clean
  WORKING_DIRECTORY ${CMAKE_CURRENT_DIR}
  )
  ADD_DEPENDENCIES(dist make_clean)
ENDIF()

IF (UNIX)
#This creates deb packages:



	add_custom_target(targz
		cpack -G TGZ --config CPackSourceConfig.cmake && tar xvfz ${CPACK_PACKAGE_NAME}-${PHASE2_VERSION}.tar.gz
		WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
		COMMENT "Creating .tar.gz" VERBATIM
	)


	add_custom_target(deb
		cd ${CPACK_PACKAGE_NAME}-${PHASE2_VERSION} && dpkg-buildpackage
		DEPENDS targz
		WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
		COMMENT "Creating Debian package" VERBATIM
	)

	file(GLOB changesdebs "${CMAKE_BINARY_DIR}/${CPACK_PACKAGE_NAME}_*.dsc")

	foreach(libfile ${changesdebs})
	    SET(changesdeb "${libfile}")
	endforeach(libfile)

	message ("changes debian file : ${changesdeb}")
	#lintian -IEi --pedantic tandem-mass_2013.06.15-1_amd64.changes
	add_custom_target(lintian
		lintian -IEi --pedantic ${changesdeb}
		DEPENDS deb
		WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
		COMMENT "lintian check" VERBATIM
	)

ENDIF()

SET(CTEST_UPDATE_TYPE git)
SET(UPDATE_COMMAND "git")
SET(UPDATE_OPTIONS "")

#ENABLE_TESTING()
#INCLUDE(CTest)
#IF (BUILD_TESTING)
#  ADD_SUBDIRECTORY(test)
#ENDIF(BUILD_TESTING)

INSTALL(PROGRAMS ${CMAKE_BINARY_DIR}/src/phase2 DESTINATION bin)

#add_subdirectory(doc)

=== src/CMakeLists.txt ===
# CMake script for peptider
# Author: Olivier Langella
# Created: 28/05/2016


FIND_PACKAGE( Qt5Core REQUIRED )
FIND_PACKAGE( Qt5Xml REQUIRED )
FIND_PACKAGE( Qt5Concurrent REQUIRED )
FIND_PACKAGE( Qt5Gui REQUIRED )
INCLUDE_DIRECTORIES(${Qt5Core_INCLUDES})
INCLUDE_DIRECTORIES(${Qt5Gui_INCLUDES})
INCLUDE_DIRECTORIES(${Qt5Xml_INCLUDES})
INCLUDE_DIRECTORIES(${Qt5Concurrent_INCLUDES})

FIND_PACKAGE( Odsstream REQUIRED )

SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${Qt5Xml_EXECUTABLE_COMPILE_FLAGS}")


FIND_PACKAGE( Pappsomspp REQUIRED )
#SET (PAPPSOMSPP_DIR  "/home/olivier/eclipse/git/pappsomspp")
# SET (PAPPSOMSPP_DIR  "/home/langella/developpement/git/pappsomspp")
# SET (PAPPSOMSPP_INCLUDE_DIR "${PAPPSOMSPP_DIR}/src")
# SET (PAPPSOMSPP_QT5_LIBRARY "${PAPPSOMSPP_DIR}/cbuild/src/libpappsomspp-qt5.so")
# SET (PAPPSOMSPP_QT4_LIBRARY "${PAPPSOMSPP_DIR}/cbuild/src/libpappsomspp-qt4.so")


set(CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake_modules)

FIND_PACKAGE(Pwiz REQUIRED)
INCLUDE_DIRECTORIES( ${Pwiz_INCLUDE_DIR})
IF (Pwiz_FOUND)
  #INCLUDE_DIRECTORIES( ${Pwiz_INCLUDE_DIR})
  #FIND_PACKAGE(Boost REQUIRED)
  #INCLUDE_DIRECTORIES( ${Boost_INCLUDE_DIRS})
ELSE (Pwiz_FOUND)
  MESSAGE("Proteowizard library not found")
  MESSAGE("did you apt-get install libpwiz-dev libboost-dev ?")
ENDIF (Pwiz_FOUND)

configure_file (${CMAKE_SOURCE_DIR}/src/config.h.cmake ${CMAKE_SOURCE_DIR}/src/config.h)

# File list
SET(CPP_FILES
  core/customspectrum.cpp
  core/digestionpipeline.cpp
  core/digestionpipelinesecondpass.cpp
  core/digestproductmatcher.cpp
  core/fastasource.cpp
  core/mzdata.cpp
  core/spectrumcompletor.cpp
  core/spectrumdatacollector.cpp
  core/xtandemspectrumprepare.cpp
  phase2.cpp
  reporter/basepsmreporter.cpp
  reporter/mzdatareporter.cpp
  reporter/odspsmreporter.cpp
  reporter/mzidentmlreporter.cpp
  utils/hardklorwrapper.cpp
  utils/linearregression.cpp
  utils/peptidestore.cpp
  utils/peptiderparams.cpp
  utils/phase1wrapper.cpp
  utils/pwizutils.cpp
  utils/threadexception.cpp
)

SET(H_FILES
#	utils/consoleout.h
#	utils/pappsomstoolsexception.h
)


SET(PEPTIDER_MOC_HDRS
  phase2.h
)
QT5_WRAP_CPP( PEPTIDER_MOC_SRCS ${PEPTIDER_MOC_HDRS} )
ADD_EXECUTABLE(phase2 ${CPP_FILES} ${PEPTIDER_MOC_SRCS})
target_include_directories(phase2 PUBLIC ${Pwiz_INCLUDE_DIR} ${PAPPSOMSPP_INCLUDE_DIR} ${ODSSTREAM_INCLUDE_DIR})
target_compile_definitions(phase2 PUBLIC ${Qt5Xml_EXECUTABLE_COMPILE_DEFINITIONS} ${Qt5Gui_EXECUTABLE_COMPILE_DEFINITIONS})
#set_target_properties(
#            phase2
#            PROPERTIES
            #COMPILE_FLAGS "${Qt5Xml_EXECUTABLE_COMPILE_FLAGS} ${Qt5Gui_EXECUTABLE_COMPILE_FLAGS}"
#            COMPILE_DEFINITIONS "${Qt5Xml_EXECUTABLE_COMPILE_DEFINITIONS} ${Qt5Gui_EXECUTABLE_COMPILE_DEFINITIONS}"
#            )
TARGET_LINK_LIBRARIES(phase2 ${PAPPSOMSPP_QT5_LIBRARY} ${Pwiz_LIBRARY} ${ODSSTREAM_QT5_LIBRARY} 
Qt5::Gui Qt5::Xml Qt5::Core Qt5::Concurrent)

=== debian/changelog ===
phase2 (0.1.0-2) stretch; urgency=medium

  * tmp dir fixed

 -- Olivier Langella <olivier.langella@u-psud.fr>  Tue, 19 Sep 2017 13:51:16 +0200

phase2 (0.1.0-1) stretch; urgency=medium

  * phase first package

 -- Olivier Langella <olivier.langella@u-psud.fr>  Tue, 19 Sep 2017 11:29:40 +0200

=== debian/control ===
Source: phase2
Maintainer: Olivier Langella <olivier.langella@u-psud.fr>
Homepage: http://pappso.inra.fr/bioinfo
Section: science
Priority: optional
Build-Depends: debhelper (>= 9), cmake (>= 2.6), libpappsomspp-dev (= 0.2.37-1), libpwiz-dev, libodsstream-dev
Standards-Version: 3.9.4

Package: phase2
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends},
         ${misc:Depends}, libpappsomspp-qt5 (= 0.2.37-1), libpwiz3,
         libodsstream-qt5
Pre-Depends: ${misc:Pre-Depends}
Description: Peptide identifier using mass spectrometry LC/MS method and MS/MS fragmentation
 Peptide identifier using mass spectrometry LC/MS method and MS/MS fragmentation.

Package: phase2-dbgsym
Auto-Built-Package: debug-symbols
Priority: extra
Section: debug 
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Peptide identifier using mass spectrometry LC/MS method and MS/MS fragmentation
 Peptide identifier using mass spectrometry LC/MS method and MS/MS fragmentation.
